Package org.apache.lucene.analysis.synonym

# Class SynonymFilter

java.lang.Object
org.apache.lucene.util.AttributeSource
org.apache.lucene.analysis.TokenStream
org.apache.lucene.analysis.TokenFilter
org.apache.lucene.analysis.synonym.SynonymFilter

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`, `Unwrappable<TokenStream>`

@Deprecated public final class SynonymFilter extends TokenFilter
Deprecated.
Use `SynonymGraphFilter` instead, but be sure to also use `FlattenGraphFilter` at index time (not at search time) as well.
Matches single or multi word synonyms in a token stream. This token stream cannot properly handle position increments != 1, ie, you should place this filter before filtering out stop words.

Note that with the current implementation, parsing is greedy, so whenever multiple parses would apply, the rule starting the earliest and parsing the most tokens wins. For example if you have these rules:

       a -> x
       a b -> y
       b c d -> z

Then input `a b c d e` parses to `y b c d`, ie the 2nd rule "wins" because it started earliest and matched the most input tokens of other rules starting at that point.

A future improvement to this filter could allow non-greedy parsing, such that the 3rd rule would win, and also separately allow multiple parses, such that all 3 rules would match, perhaps even on a rule by rule basis.

NOTE: when a match occurs, the output tokens associated with the matching rule are "stacked" on top of the input stream (if the rule had `keepOrig=true`) and also on top of another matched rule's output tokens. This is not a correct solution, as really the output should be an arbitrary graph/lattice. For example, with the above match, you would expect an exact `PhraseQuery` `"y b c"` to match the parsed tokens, but it will fail to do so. This limitation is necessary because Lucene's TokenStream (and index) cannot yet represent an arbitrary graph.

NOTE: If multiple incoming tokens arrive on the same position, only the first token at that position is used for parsing. Subsequent tokens simply pass through and are not parsed. A future improvement would be to allow these tokens to also be matched.

## Nested Class Summary

## Nested classes/interfaces inherited from class org.apache.lucene.util.AttributeSource

`AttributeSource.State`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`TYPE_SYNONYM`
Deprecated.

### Fields inherited from class org.apache.lucene.analysis.TokenFilter

`input`

### Fields inherited from class org.apache.lucene.analysis.TokenStream

`DEFAULT_TOKEN_ATTRIBUTE_FACTORY`

## Constructor Summary

Constructors
Constructor
Description
`SynonymFilter(TokenStream input, SynonymMap synonyms, boolean ignoreCase)`
Deprecated.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`incrementToken()`
Deprecated.
`void`
`reset()`
Deprecated.

### Methods inherited from class org.apache.lucene.analysis.TokenFilter

`close, end, unwrap`

### Methods inherited from class org.apache.lucene.util.AttributeSource

`addAttribute, addAttributeImpl, captureState, clearAttributes, cloneAttributes, copyTo, endAttributes, equals, getAttribute, getAttributeClassesIterator, getAttributeFactory, getAttributeImplsIterator, hasAttribute, hasAttributes, hashCode, reflectAsString, reflectWith, removeAllAttributes, restoreState, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Field Details

### TYPE_SYNONYM

public static final String TYPE_SYNONYM
Deprecated.

See Also:
  - Constant Field Values

## Constructor Details

### SynonymFilter

public SynonymFilter(TokenStream input, SynonymMap synonyms, boolean ignoreCase)
Deprecated.

Parameters:
  `input` - input tokenstream
  `synonyms` - synonym map
  `ignoreCase` - case-folds input for matching with `Character.toLowerCase(int)`. Note, if you set this to true, it's your responsibility to lowercase the input entries when you create the `SynonymMap`

## Method Details

### incrementToken

public boolean incrementToken() throws IOException
Deprecated.

Specified by:
  `incrementToken` in class `TokenStream`
Throws:
  `IOException`

### reset

public void reset() throws IOException
Deprecated.

Overrides:
  `reset` in class `TokenFilter`
Throws:
  `IOException`